#ifndef __qdrp_global_h__
#define __qdrp_global_h__

#include <qdrp/qdrp_imports.h>

// **************************************************************************************************************************************************
// <CONSTANTES GLOBALES>
// **************************************************************************************************************************************************

class QDRP_global
{
public:
	//==========================================================================================================================//
	// Configuración de red													    //
	//==========================================================================================================================//	
	static const u_int8_t DEFAULT_NETWORK_ID = 0xBD;
	static const u_int8_t MAX_HOPS_TO_SINK = 127;
	static const u_int8_t UNKNOWN_HOPS_TO_SINK = 0xFF;

	//==========================================================================================================================//
	// Tamaño del mapa de nodos hijos											    //
	//==========================================================================================================================//
	static const u_int8_t NODE__NUM_CHILD_SLOTS = 5;	// ( 1 => topología en cadena margarita )
	static const u_int8_t SINK__NUM_CHILD_SLOTS = 10;	// ( Un nodo sumidero puede conectar a tantos nodos como le plazca )

	//==========================================================================================================================//
	// Configuración de temporizadores											    //
	//==========================================================================================================================//
	static const u_int8_t CONNECTION_TIMER_CYCLES = 6;	// nº de sub_intervalos de tiempo en un temporizador de conexión
						//25
	static const double HEARTBEAT_INTERVAL  = 20.0;		// tiempo (en segundos) para lanzar sendme show off
	static const double new_route_int	= 70.0; //tiempo en seg. para buscar nuevas rutas, 15seg + que el hearbeat interval

	static const double sendme_show_off_int    = 0.6;	//envia sendme showoff mientras estoy offline
	static double JOIN_NETWORK_INTERVAL(){return 2.1;}//{ return 2.0 * HEARTBEAT_INTERVAL; }
	
	static double CONNECTION_TIMEOUT(){ return 60.0; }
	static double CONNECTION_TIMER_CYCLE_INTERVAL() { return CONNECTION_TIMEOUT() / (double) CONNECTION_TIMER_CYCLES; } //10
	static double sendme_show_off_interval(){ return sendme_show_off_int; }
	static double new_route_interval(){ return new_route_int; }

	//==========================================================================================================================//
	// TXon y RXon de mensajes												    //
	//==========================================================================================================================//
	static double DATA_PACKET_DELAY(){ return Random::uniform(0.000, 0.020); }
	static double QDRP_BROADCAST_PACKET_DELAY(){ return Random::uniform(0.000, 0.200); }
	static double QDRP_UNICAST_PACKET_DELAY(){ return Random::uniform(0.000, 0.020); }
	static double PACKET_RETRANSMISSION_DELAY(){ return Random::uniform(0.000, 0.020); }

	//==========================================================================================================================//
	// Miscelánea														    //
	//==========================================================================================================================//
	static double CURRENT_TIME(){ return Scheduler::instance().clock(); }
	static void cancel_timer(TimerHandler* timer){ if(timer->status() == TIMER_PENDING) { timer->cancel(); } }
};

#endif

