#include <qdrp/qdrp_node.h>
#include "wpan/p802_15_4nam.h"
// **************************************************************************************************************************************************
// NODO QDRP
// **************************************************************************************************************************************************

//==================================================================================================================================//
// Constructor/Destructor 													    //
//==================================================================================================================================//
qdrp_node::qdrp_node()
{
	address_ = IP_BROADCAST;
	network_id_ = QDRP_global::DEFAULT_NETWORK_ID;
	hops_to_sink_ = QDRP_global::UNKNOWN_HOPS_TO_SINK;
	num_child_nodes_ = 0;
	max_child_nodes_ = QDRP_global::NODE__NUM_CHILD_SLOTS;
	lqi_packet_ = 0;
//	route_batt_ = 0;
}


qdrp_node::qdrp_node(nsaddr_t address)
{
	address_ = address;
	network_id_ = QDRP_global::DEFAULT_NETWORK_ID;
	hops_to_sink_ = QDRP_global::UNKNOWN_HOPS_TO_SINK;
	num_child_nodes_ = 0;
	max_child_nodes_ = QDRP_global::NODE__NUM_CHILD_SLOTS;
	lqi_packet_ = 0;
//	route_batt_ = 0;
}

qdrp_node::~qdrp_node(){}


//==================================================================================================================================//
// Funciones		 													    //
//==================================================================================================================================//
// Comparador //
bool qdrp_node::compare(qdrp_node a, qdrp_node b)
{

bool result;

int lqi_a, lqi_b;
float porc_batt_a, porc_batt_b, result_a, result_b;


Node* node_a = Node::get_node_by_address(a.address_);
Node* node_b = Node::get_node_by_address(b.address_);


///////////////////////////////////////////////////////////////////

lqi_a = (a.lqi_packet() >= 70)?70:a.lqi_packet();
lqi_b = (b.lqi_packet() >= 70)?70:b.lqi_packet();

porc_batt_a = ((node_a->energy_model()->energy()*100/float(node_a->energy_model()->initialenergy())) >= 65.0)?	65.0:(node_a->energy_model()->energy()*100/float(node_a->energy_model()->initialenergy()));

porc_batt_b = ((node_b->energy_model()->energy()*100/float(node_b->energy_model()->initialenergy())) >= 65.0)?	65.0:(node_b->energy_model()->energy()*100/float(node_b->energy_model()->initialenergy()));

result_a = (255.0*(1/float((a.hops_to_sink()+1))) + (lqi_a*0.5) + ((porc_batt_a/float(a.num_child_nodes()+1))*0.15 ));

result_b = (255.0*(1/float((b.hops_to_sink()+1))) + (lqi_b*0.5) + ((porc_batt_b/float(b.num_child_nodes()+1))*0.15 ));


if(result_a >= result_b)
{
	result=true;
}
else
   if(result_a < result_b)
   {
	result=false;
   }
   else
	result=true;


return result;
}

// Realiza una copia de la información de un nodo //
void qdrp_node::copy(qdrp_node* dest, qdrp_node* src)
{
	dest->address_ = src->address_;
	dest->network_id_ = src->network_id_;
	dest->hops_to_sink_ = src->hops_to_sink_;
	dest->num_child_nodes_ = src->num_child_nodes_;
	dest->max_child_nodes_ = src->max_child_nodes_;
}

// **************************************************************************************************************************************************
// FIN DE: NODO QDRP
// **************************************************************************************************************************************************

