#ifndef __qdrp_node_h__
#define __qdrp_node_h__

#include <qdrp/qdrp_imports.h>
#include <qdrp/qdrp_global.h>

// **************************************************************************************************************************************************
// NODO QDRP
// **************************************************************************************************************************************************

class qdrp_node
{
	//==========================================================================================================================//
	// Características de un nodo												    //
	//==========================================================================================================================//
	nsaddr_t address_;			// Dirección IP del nodo.
	u_int8_t network_id_;			// Identificador de red, utilizado en caso de que haya más de un sumidero.
	u_int8_t hops_to_sink_;			// Nº de saltos hasta el sumidero de la red a la que está conectado el nodo. 
	u_int8_t num_child_nodes_;		// Nº de nodos hijos activos
	u_int8_t max_child_nodes_;		// Nº máximo de nodos hijos que puede soportar el nodo
	u_int8_t lqi_packet_;
//	u_int8_t route_batt_;

public:
	//==========================================================================================================================//
	// Constructor/Destructor 											     	    //
	//==========================================================================================================================//
	qdrp_node();
	qdrp_node(nsaddr_t address);
	~qdrp_node();

	//==========================================================================================================================//
	// Acceso a: características de un nodo										     	    //
	//==========================================================================================================================//
	inline nsaddr_t& address(){ return address_; }
	inline u_int8_t& network_id(){ return network_id_; }
	inline u_int8_t& hops_to_sink(){ return hops_to_sink_; }
	inline u_int8_t& num_child_nodes(){ return num_child_nodes_; }
	inline u_int8_t& max_child_nodes(){ return max_child_nodes_; }
	inline u_int8_t& lqi_packet(){ return lqi_packet_; }
//	inline u_int8_t& route_batt(){ return route_batt_;}

	//==========================================================================================================================//
	// Funciones													     	    //
	//==========================================================================================================================//
	static void copy(qdrp_node* dest, qdrp_node* src);	// Obtiene la copia de un nodo
	static bool compare(qdrp_node a, qdrp_node b);		// Compara dos nodos, según un criterio (a < b) o (a > b)
};


// **************************************************************************************************************************************************
// FIN DE: NODO QDRP
// **************************************************************************************************************************************************

#endif

