#ifndef __qdrp_parent_selection_list_h__
#define __qdrp_parent_selection_list_h__

#include <qdrp/qdrp_imports.h>
#include <qdrp/qdrp_global.h>
#include <qdrp/qdrp_node.h>

// *********************************************************************************************************************************************** //
// LISTA DE SELECCIÓN DE CANDIDATOS A NODO PADRE
// *********************************************************************************************************************************************** //

class qdrp_parent_selection_list
{
	//==========================================================================================================================//
	// Propiedades													     	    //
	//==========================================================================================================================//
	std::list<qdrp_node> node_list_;			// lista de nodos

	bool is_sorted_;					// ¿la lista está ordenada?

public:
	//==========================================================================================================================//
	// Constructor/Destructor 											     	    //
	//==========================================================================================================================//
	qdrp_parent_selection_list();				// Constructor
	~qdrp_parent_selection_list();				// Destructor
	void clear();						// Vaciado / limpieza / borrado

	//==========================================================================================================================//
	// Métodos de consulta 												     	    //
	//==========================================================================================================================//
	bool is_empty();					// comprueba si la lista está vacía
	qdrp_node get_best_candidate();				// obtiene el "mejor candidato" para la conexión

	//==========================================================================================================================//
	// Modificadores 												     	    //
	//==========================================================================================================================//
	void register_node(qdrp_node node);			// añade/actualiza o descarta (automáticamente) un nodo en la lista
	void delete_best_candidate();				// elimina el mejor candidato a nodo padre de la lista
private:
	//==========================================================================================================================//
	// Funciones privadas 												     	    //
	//==========================================================================================================================//
	std::list<qdrp_node>::iterator find_node_by_address(nsaddr_t address);
};


// *********************************************************************************************************************************************** //
// FIN DE: LISTA DE SELECCIÓN DE CANDIDATOS A NODO PADRE
// *********************************************************************************************************************************************** //

#endif

